<template>
  <el-dialog
    v-model="dialogFormVisible"
    :title="title"
    width="500px"
    @close="close"
  >
    <el-form ref="form" :model="form" :rules="rules" label-width="60px">
      <el-form-item :label="$t('dataEnquiry.xm')" prop="projectIds">
        <el-select
          v-model="form.projectIds"
          size="small"
          filterable
          multiple
          placeholder="请选择"
        >
          <el-option
            v-for="item in projectData"
            :key="item.id"
            :label="item.name"
            :value="item.id"
          ></el-option>
        </el-select>
      </el-form-item>
    </el-form>
    <div class="dialog-footer">
      <el-button type="primary" size="small" @click="save">确 定</el-button>
      <el-button size="small" @click="close">取 消</el-button>
    </div>
  </el-dialog>
</template>

<script>
import { alarmProjects, allProject, assignToProjects } from '@/api/alarmuser';
export default {
  data() {
    return {
      form: {
        userId: '',
        projectIds: [],
      },
      rules: {
        projectIds: [
          { required: true, trigger: 'change', message: '请选择项目' },
        ],
      },
      projectData: [],
      clearable: true,
      title: '',
      dialogFormVisible: false,
    };
  },
  created() {},
  methods: {
    async getProjectData() {
      const { data } = await allProject();
      this.projectData = data;
    },
    bindDevice(row) {
      this.title = '绑定项目';
      this.form.userId = row.userId;
      this.dialogFormVisible = true;
      this.getProjectData();
      this.getAlarmProjects();
    },
    async getAlarmProjects() {
      const { data } = await alarmProjects({ userId: this.form.userId });
      this.form.projectIds = data;
    },
    close() {
      this.$refs['form'].resetFields();
      this.form = this.$options.data().form;
      this.dialogFormVisible = false;
      this.$emit('fetch-data');
    },
    save() {
      console.log(this.form);
      this.$refs['form'].validate(async valid => {
        if (valid) {
          const { msg } = await assignToProjects(this.form);
          this.$notify({
            title: msg,
            type: 'success',
          });
          this.$refs['form'].resetFields();
          this.dialogFormVisible = false;
          this.$parent.fetchData();
        } else {
          return false;
        }
      });
    },
  },
};
</script>
<style>
.select {
  width: 100%;
}
</style>
